/*
 * Mgraphics.h
 *		Motif/Lesstif graphics library header file
 *
 * Programmer: Park Jae-Ho(jrogue@netian.com), Lee Hai-Young
 *
 * This project is inspired by the WINIO library in UNDOCUMENTED WINDOWS.
 * This library can be copied, modified, used by others,
 * BUT PLEASE PROVIDE THAT ABOVE NOTICE APPEAR IN ALL COPIES OF THIS LIBRARY.
 */

#ifndef MGRAPHICS_H
#define MGRAPHICS_H

#include <Xm/Xm.h>
#include "Wcommon.h"

/* for definition of Screen structure */

typedef struct mscreen {
	Widget 	screen ;
	Pixmap  pixmap ;
	GC	gc ;
	int	curix, curiy ;
	int	width, height ; /* inserted by rogue for compatibility */
	struct  mscreen *next ;
} MScreen;

/* for definition of Color set */

enum COLORS {
	BLACK,
	BLUE,
	GREEN,
	CYAN,
	RED,
	MAGENTA,
	BROWN,
	LIGHTGRAY,
	DARKGRAY,
	LIGHTBLUE,
	LIGHTGREEN,
	LIGHTCYAN,
	LIGHTRED,
	LIGHTMAGENTA,
	YELLOW,
	WHITE
} ; 

/* for initialize routine */

void MinitGraph ( int argc, char **argv );
void MloopGraph ( void );
void showGraph  ( void );
void hideGraph  ( void );

/* for Screen library */

MScreen *CreateScreen( int iwidth, int iheight ) ;
void	SetScreen( MScreen *target ) ;
void    ClearScreen( void ) ;

/* for graphics library */

int  getmaxx ( void );
int  getmaxy ( void );

void putpixel ( int ix, int iy );
void line ( int ixStart, int iyStart, int ixFinish, int iyFinish );

void setcolor ( int colorno );
void setnamedcolor ( char *colorname ) ;
void setbkcolor ( int colorno );
void setnamedbkcolor ( char *colorname ) ;
void clearScreen ( void );

/* inserted by rogue for reading a key from screen */

char Ggetch ( void );

#endif
