/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    R E C T A N G L E . C                     //
//                                                            //
//         Ŭ Rectangle  ڵ                       //
//                                                            //
//************************************************************//

#include "rectangle.h"

//   Rectangle ߻ȭ   ϰ ִ.

ShapeRep *rectangle = 0;      // Rectangle exemplar

void
Rectangle::init() {
    // Rectangle  ִ   ʱȭϴµ,
    // main     ʱȭ ϵ Ѵ.
    //  ڷ  ù° Shape::gcCommon ȣ 쿡
    // ʱȭ Ѵ.
    rectangle = new Rectangle(Exemplar(0));
}

Shape
Rectangle::make()
{
    // ⺻ 簢 Ѵ.
    Rectangle *retval = new Rectangle;
    retval->p1 = retval->p2 = Coordinate(0,0);
    retval->exemplarPointer = this;
    return *retval;
}

Shape
Rectangle::make(Coordinate pp1, Coordinate pp2)
{
    //  ҿ 簢 Ѵ.
    Rectangle *retval = new Rectangle;
    retval->p1 = pp1;
    retval->p2 = pp2;
    retval->exemplarPointer = this;
    return *retval;
}

void
Rectangle::draw() {
    int Sizeof = poolInitialized? poolInitialized:
        sizeof(Rectangle);
    printf("<Rectangle object %c>",
        'A' + (((char *)this-(char *)heap)/Sizeof));
}

void
Rectangle::move(Coordinate) {
    // . . .
}

void
Rectangle::rotate(double) {
    // . . .
}

//************************************************************//
//                                                  //
//************************************************************//

char *Rectangle::heap = 0;             // operator new  Ǯ
size_t Rectangle::poolInitialized = 0; // Rectangle ũ

void
Rectangle::gc(size_t nbytes) {
    // Rectangle νϽ   ÷ Ѵ.
    printf("Rectangle::gc(%d) entered\n", nbytes);
    gcCommon(nbytes, poolInitialized, PoolSize, heap);
}

void *
Rectangle::operator new(size_t nbytes) {
    // ο Rectangle  ޸𸮸  Ѵ.
    if (poolInitialized - nbytes) {
        gcCommon(nbytes, poolInitialized, PoolSize, heap);
        poolInitialized = nbytes;
    }
    Rectangle *tp = (Rectangle *)heap;
    // Ǹ α׷Ӷ ⿡ ޸  ׽Ʈ ߰ ̴. 
    while (tp->inUse) {
        tp = (Rectangle*)(((char*)tp) + Round(nbytes));
    }
    tp->gcmark = 0;
    tp->inUse = 1;
    return (void*) tp;
}

void Rectangle::operator delete(void *) {
    // ƹ ϵ  ʴ´ --   Rectangle::gc  캸 ٶ.
}

Rectangle::Rectangle() {
    // ũ vptr  ⿡ ִ.
}

Rectangle::Rectangle(const Rectangle& t) {
    //  
    p1 = t.p1;
    p2 = t.p2;
}

Rectangle::Rectangle(Exemplar e) : ShapeRep(e) {
    //  Exemplar   
}
