/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    R E C T A N G L E . H                     //
//                                                            //
//         Ŭ Rectangle  ̽                 //
//                                                            //
//************************************************************//

#define _RECTANGLE_H
#ifndef _RECTANGLE_H
#include "shaperep.h"
#include "coordinate.h"

//  Ŭ Rectangle ߻ȭ  ̽ Ѵ.

class Rectangle: public ShapeRep {
public:
    // exemplar 
    Shape make();
    Shape make(Coordinate, Coordinate);

    // ⺻ 
    Rectangle();

    // Exemplar 
    Rectangle(Exemplar);
    void draw();

    // Rectangle   ִ ۾
    void move(Coordinate);
    void rotate(double);

    // ޸  ƾ
    void *operator new(size_t);
    void operator delete(void *);
    void gc(size_t = 0);
    static void init();
private:
    //  Լ  Rectangle  ȣ  .
    Shape make(Coordinate, Coordinate, Coordinate) {
        return *aShape;
    }
    Shape make(Coordinate) {
        return *aShape;
    }
    Coordinate p1, p2;
private:
    // ޸  ڷ 
    static char *heap;
    static size_t poolInitialized;
    enum { PoolSize = 5 };
};

// Rectangle exemplar  
extern ShapeRep *rectangle;
#endif
