/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :      S H A P E . C                           //
//                                                            //
//         Ŭ Shape  ڵ                           //
//                                                            //
//************************************************************//

#include "shape.h"
#include "shaperep.h"
#include "trinangle.h"
#include "rectangle.h"
#include "List.h"

// Ŭ Shape  Shape  ޸  ۾ κ Ѵ.

//    ϴ Shape νϽ ٷ.
List<Topp> *Shape::allShapes = 0;

// Ŭ ShapeRep  Ŭ    Exemplar 
List<Thingp> *Shape::allShapeExemplars = 0;

// Shape exemplar
extern Shape *shape = 0;

void
Shape::init() {
    // Shape    ڷ  ʱȭؼ
    // main ʱȭ    ֵ Ѵ.
    allShapes = new List<Topp>;
    allShapeExemplars = new List<Thingp>;
    shape = new Shape;

    // ShapeRep Ÿ ʱȭ Ѵ.
    ShapeRep::init();
    Triangle::init();
    Rectangle::init();
}

Top *
Shape::doit() {
    // ڰ ؼ ƿƼ Ȱ  ִ  Լ̴.
    return 0;
}

Shape::Shape() {
    // ⺻  
    Topp tp = this;

    // allShape Ͽ ڽ Ѵ.
    allShapes->put(tp);

    //  Shape    𸣹Ƿ,   ̷θ  ´.
    rep = new ShapeRep;
}

Shape::~Shape() {
    Listiter<Topp> tp = *allShapes;
    Topp t;
    for ( tp.reset(); tp.next(t); ) {
        if (t == (Thingp)this) {
            tp.remove_prev(t);
            break;
        }
    }
    if (allShapes->length() == 0) {
        //  յ   ÷
        gc();
    }
}

Shape::Shape(Shape &x) {
    //  
    Thingp tp = (Thingp) this;

    // allShape Ͽ ڽ Ѵ.
    allShapes->put(tp);

    // ܼ Ű rep Ų.
    rep = x.rep;
}

Shape::Shape(ShapeRep &x) {
    // ShapeRep Shape .
    // ַ Triangle, Rectangle  ShapeRep
    // ڿ ȯ Shape µ ȰѴ
    // (ڴ   Ŭ   ).
    Topp tp = this;

    // allShape Ͽ ڽ Ѵ.
    allShapes->put(tp);

    // :  no ->ref();  ȣڴ ݵ 纻  Ѵ!
    rep = &x;
}

Shape&
Shape::operator=(Shape &x) {
    //  Ѵ. rep  Űµ ϴ
    //  .  ÷ ̸  ̴.
    rep = x.rep;
    return *this;
}

Top *
Shape::type() {
    // Shape Ÿ ڽ exemplar̴.
    return shape;
}

void
Shape::dataUpdate(Thingp &oldExemplar,
                               const Thingp newExemplar) {
    //  Լ ShapeRep  Ŭ Ŭ ü Ѵ.
    // ̴  Լ  Ǿ, ο Ŭ
    // ǿ   Ǿ Ѵ. ̴ 
    // α׷Ӱ cutover Լ ؼ Shape  νϽ
    // ȣ  ǹ̷  縦 Ű ͸
    // ȯ Ѵ.

    ShapeRep* savedExemplar = (ShapeRep*) oldExemplar;
    Topp tp = 0;

    // ݺ   纻 ´. ߰ ο
    //  ٽ   ʴ´!
    //   Լ ƿ 簪 ȸ ̴.
    List<Topp> staticCopy = *allShapes;

    // exemplar Ѵ.
    oldExemplar = newExemplar;

    //  exemplar    ü  cutover θ
    Listiter<Topp> shapeIter = staticCopy;
    for ( shapeIter.reset(); shapeIter.next(tp);  ) {
        Shapepointer sp = (Shapepointer)tp;
        if (sp->rep->type() == (Thingp)savedExemplar) {
            if (sp->rep->docutover()) {
                ShapeRep *oldrep = sp->rep;
                printf("\tchanging shape 0x%x to new format\n",
                    oldrep);
                sp->rep = (ShapeRep*)sp->rep->cutover();

                // ݵ ۾  rep ⼭ ؾ Ѵ.
                //  ÷ʹ ̷ ۾   ̴.
                //   rep  ٱ  ̴.
                oldrep->ShapeRep::~ShapeRep();
            }
        }
    }

    //  exemplar Shape ϴ   exemplar Ͽ
    // Ѵ.   exemplar  ̻ ߻  exemplar Ϻη
    //  ʴ´.
    UnRegister(savedExemplar);
}

void
Shape::gc() {
    // Shape  ÷: ShapeRep   Ŭ
    //   ʴ ü  Ѵ. Ŀ
    // ˰ ȰѴ.

    // Ŀ ˰ ݺ:     ǥѴ.
    Listiter<Topp> shapeIter = *allShapes;
    shapeIter.reset();
    for ( Topp tp = 0; shapeIter.next(tp);  ) {
        Shapepointer sp = (Shapepointer)tp;
        if (sp->rep) {
            sp->rep->mark();
        }
    }        

    // Ŀ ˰ Ĺݺ: Ѵ.   Ÿ
    // ڱ ڽ gc ȰϿ ڽ Ǯ ϵ .
    Listiter<Thingp> shapeExemplarIter = *allShapeExemplars;
    shapeExemplarIter.reset();
    for ( Thingp anExemplar = 0;
                shapeExemplarIter.next(anExemplar);  ) {
        ShapeRep *thisExemplar = (ShapeRep*)anExemplar;
        thisExemplar->gc(0);
    }

    // Ŀ "", "" ٲ
    ShapeRep::FromSpace ^= 1;
    ShapeRep::ToSpace ^= 1;
}

void
Shape::Register(ShapeRep *s) {
    // ShapeRep exemplar ڽ Shape Ҿ ϴ ƾ
    Thingp tp = s;
    allShapeExemplars->put(tp);
}

void
Shape::UnRegister(ShapeRep *s) {
    // exemplar θ ϵ Ѵ
    // (    ü )
    Thingp tp = 0;
    Listiter<Thingp> shapeIter = *allShapeExemplars;
    for ( shapeIter.reset(); shapeIter.next(tp); ) {
        if (tp == (Thingp)s) {
            shapeIter.remove_prev(tp);
        }
    }
}
