/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    S H A P E R E F . C                       //
//                                                            //
//         Ŭ ShapeRep  ڵ                        //
//                                                            //
//************************************************************//

// ShapeRep μ Shape ϴ   Ŭ   Ŭ̴.
//  Ŭ shape  οϴ    ShapeRep Ļ Ŭ
// ο Ѵ.

#include "shaperep.h"
#include "rectangle.h"
#include "triangle.h"

// ȯ Űµ ϴ ""̴.
Shape *ShapeRep::aShape = 0;

// Ŀ ˰  "" "" ϴ Ʈ̴.
//  ֱ⸶   ٲ۴.
unsigned char ShapeRep::FromSpace = 0, ShapeRep::ToSpace = 1;

void ShapeRep::init() {
    // Ŭ ڷ  ʱȭѴ.
    aShape = new Shape;
}

void *
ShapeRep::operator new(size_t l) {
    // Ļ Ŭ ̵Ѵ.
    return ::operator new(l);
}

void
ShapeRep::operator delete(void *p) {
    // Ļ Ŭ ̵Ѵ.
    ::operator delete(p);
}

Thing *
ShapeRep::type() {
    // ShapeRep Ļ Ŭ Ÿ exemplarPointer Ѵ.
    return (Thingp)exemplarPointer;
}

Shape
ShapeRep::make() {
    // ⺻ ShapeRep 
    return *aShape;
}

Shape
ShapeRep::make(Coordinate c1, Thingp) {
    //   ϳ: Point ü
    return point->make(c1);
}

Shape
ShapeRep::make(Coordinate c1, Coordinate c2, Thingp type) {
    // ΰ  װ Ҿ Shape ü 
    // exemplar : Line, Rectangle
    return ((ShapeRep *)type)->make(c1, c2);
}

Shape
ShapeRep::make(Coordinate c1, Coordinate c2, Coordinate c3,
           Thingp type) {
    //   װ Ҿ Shape ü 
    // exemplar : Triangle, Arc, Parallelogram
    return ((ShapeRep*)type)->make(c1, c2, c3);
}

Shape
ShapeRep::make(Coordinate c1) {
    // ǥ ϳ Shape .
    // ⺻ Point ȯѴ.
    return make(c1, (Thingp)&point);
}

Shape
ShapeRep::make(Coordinate c1, Coordinate c2) {
    // ǥ ΰ Shape .
    // ⺻ Rectangle ȯѴ
    return make(c1, c2, rectangle);
}

Shape
ShapeRep::make(Coordinate c1, Coordinate c2, Coordinate c3) {
    // ǥ  Shape .
    // ⺻ Triangle ȯѴ 
    return make(c1, c2, c3, triangle);
}

void
ShapeRep::gcCommon(size_t nbytes, const size_t poolInitialized,
        const int PoolSize, Char_p &heap) {
    //  ShapeRep   ÷.  Լ
    // Ŀ ˰ ι° Ĺݺ "" ۾ κ
    // Ͼ ̴.  Լ Ļ Ŭ gc ƾ
    //  μ ؼ  ȣѴ.

    // s ؼ ü ũ ´. nbytes ߴٸ,
    // ̸ Ѵ.   ũ⿡ ȭ Ѵ(ƴϸ,
    // ʱȭ  ۾  ϵ οѴ).
    // ׷ ʴٸ, poolInitialized   Ѵ.
    size_t s = nbytes? nbytes: poolInitialized;

    //    Round Լ ҷ ũ⸦ .
    size_t Sizeof = Round(s);

    // 0 ƴ Ű ־, ̴ ü ũ̴.
    // ̴  Ǯ  ο Ǯ Ҵؾ  Ѵ.
    // ̷ ۾ ʱ⿡ ѹ, ׸ Ŭ  Ͼ
    //  ѹ Ѵ.
    if (nbytes) heap = new char[PoolSize * Sizeof];

    ShapeRep *tp = (ShapeRep *)heap;

    //  ûѴ.
    for (int i = 0; i < PoolSize; i++) {
        switch (nbytes) {
        case 0:   // Ϲ  ÷ 
                  //  ǥð Ǿ, ȯ  ̸,
                  // FromSpace ҸŰ.
            if (tp->inUse) {
                if (tp->gcmark || tp->space != FromSpace) {
                    //  .
                    tp->space = ToSpace;
                } else if (tp != tp->type()) {
                    // ü ȯ ʿ䰡 ִ.
                    tp->ShapeRep::~ShapeRep();
                    tp->inUse = 0;
                    printf("ShapeRep::gcCommon ");
                    printf("Reclaimed Shape object %c\n",
                     'A' + (((char *)tp-(char *)heap)/Sizeof));
                }
            }
            break;
        default:   // ޸ 븦 ʱȭѴ.
            tp->inUse = 0;
            break;
        }
        tp->gcmark = 0;
        tp = (ShapeRep*)(Char_p(tp) + Sizeof);
    }
}

ShapeRep::ShapeRep(Exemplar) {
    // ShapeRep exemplar   
    // (׷ ߿ ʴ)
    //
    // ش Exemplar  ڿ ⺻ ڸ ϱ   Ÿ
    // ϶.
    exemplarPointer = this;
    shape->Register(this);
}

void
ShapeRep::rotate(double) {
    //   Լó ൿѴ.
    printf("ShapeRep::rotate(double)\n");
}

void
ShapeRep::move(Coordinate) {
    //   Լó ൿѴ.
    printf("ShapeRep::move(Coordinate)\n");
}

void
ShapeRep::draw() {
    //   Լó ൿѴ. 
    // ܼ ׸ Ÿ ̸ Ѵ.
    printf("<Shape>");
}

void
ShapeRep::erase() {
    //   Լó ൿѴ.
    printf("ShapeRep::erase()");
}

void
ShapeRep::gc(size_t) {
    //   Լó ൿѴ.
}

void
ShapeRep::mark() {
    // Ŀ ǥ ܰ迡 Shape Ѵ.
    gcmark = 1;
}

ShapeRep::ShapeRep() {
    // ⺻ 
    exemplarPointer=this;
    gcmark=0;
    space=ToSpace;
    inUse=1;
}

ShapeRep::~ShapeRep() {
    // Ҹڴ ƹ ϵ  ʴ´.
}
