/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//     F I L E :    S H A P R P E P . H                       //
//                                                            //
//         Ŭ ShapeRep  ̽                  //
//                                                            //
//************************************************************//

#ifndef _SHAPEREP_H
#define _SHAPEREP_H
#include "shape.h"
#include "coordinate.h"

class ShapeRep: public Thing {
public:
    /*  - ڰ ⿡ ִ. operator-> Ȱϱ
     *   Ŭ  Shape Ŭ 䳻  
     * ָؾ Ѵ. ׷ ұϰ, Shape rep ʵ 
     * Ÿ ߸ Ѵ.  ڴ ⿡  Shape
     * Ŭ ִ.
     *
     * ȯ Ÿ ⺻ Ÿ̳ Shape Ÿ̳ Shape& Ÿ̳
     * ü ڷ Ÿ  ϳ̿ Ѵ.
     */

    virtual void rotate(double);
    virtual void move(Coordinate);
    virtual void draw();
    virtual void erase();

    // 
    Shape make(Coordinate,Thingp);
    Shape make(Coordinate,Coordinate,Thingp);
    Shape make(Coordinate,Coordinate,Coordinate,Thingp);

    //  Լ Ļ Ŭ ̵ Ѵ.
    // ⺻ ൿ   ⺻  Thingp Ҿ
    //  ִ Լ ȣϴ ̴.
    virtual Shape make();
    virtual Shape make(Coordinate);
    virtual Shape make(Coordinate,Coordinate);
    virtual Shape make(Coordinate,Coordinate,Coordinate);

    // Ŀ ˰  ϵ  ü ǥϴ
    // ƾ̴.
    virtual void mark();

    // type ü exemplar Ű ͸ ȯѴ.
    Thing *type();

    //  ÷ Ѵ. Ű 0̸  Ǯ ûѴ.
    // Ű 0 ƴϸ, ϴ ũ ü ϵ
    // ο Ǯ . ׸  Ǯ ؾ.
    virtual void gc(size_t = 0);

    // Ŭ 
    ShapeRep();
    ~ShapeRep();
    ShapeRep(Exemplar);

    // ̰, Ŭ   ʱȭ  ϴµ .
    static void init();
protected:
    friend class Shape;
    Coordinate center;

    //   "Ÿ ʵ"̴.
    Top *exemplarPointer;

    // ޸   ̴.
    // space FromSpace ToSpace̸, gcmark
    // Ŀ ˰ Ͽ ü  ǥ Ʈ̴.
    // inUse  ü   ȣڰ ȯ,
    //  ÷Ͱ  ȯ ʾ ǹѴ.
    unsigned char space:1, gcmark:1, inUse:1;
protected:
     // Ŀ  ÷  Ϲ ó( ܰ) Ѵ.
    static void gcCommon(size_t nbytes,
        const size_t poolInitialized,
        const int PoolSize, Char_p &h);

    //   "" Ŀ ˰   θ
    // Ѵ.   ÷ ֱ⸶ .
    static unsigned char FromSpace, ToSpace;

    // Ϲ ޸  ڷ, gc Ǯ ϴµ
    // δ.
    static void *operator new(size_t);
    static void operator delete(void *);

    // ⺻ ȯ   Ÿ  
    static Shape *aShape;
};
#endif
