/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//************************************************************//
//                                                            //
//         :    V 3 T R I A N G L E C U T O V E R . C     //
//                                                            //
//         3 Triangle ڵ带  cutover  ڵ         //
//                                                            //
//************************************************************//

#include "v3triangle.h"
#include "Map.h"

// --------------------------------------------------------------

class v2Triangle: public ShapeRep {
public:
    Shape make();
    Shape make(Coordinate, Coordinate, Coordinate);
    v2Triangle();
    void move(Coordinate);
    void *operator new(size_t);
    void operator delete(void *);
    void gc(size_t = 0);
    void draw();
    v2Triangle(Exemplar);
    static void init();
private:
    friend Thing *Triangle::cutover();  // ȯ  оִ´.
    static void poolInit(size_t);
    Shape make(Coordinate) { return *aShape; }
    Shape make(Coordinate, Coordinate) { return *aShape; }
    Coordinate p1, p2, p3;
};

// --------------------------------------------------------------

//   ȯ ûϴ   ü ȯ  ο ü
// ϱ  Ѵ.
// ̷   ü   û 
//  û  ȯ   ִ.

Map<Thingp, Thingp> objectMap;

Thing *
Triangle::cutover() {
    // ȯ ﰢ Ű ͸ ȯϷ Ѵ.
    Triangle *retval = this;

    // ޹ νϽ   ﰢ Ÿ̴.
    //  ﰢ  v2Triangle̶ ̸ Ѵ.
    // Ŭ Triangle 3̴.
    v2Triangle *old = (v2Triangle *)this;
    Thingp oldtp = this;
    ShapeRep *oldsr = (ShapeRep*)this;

    if (objectMap.element(oldtp)) {
        //  ̹ ȯߴٸ, ٽ ѹ ȯ ʴ´.
        // ܼ  ȯ ȯѴ.
        retval = (Triangle*)(objectMap[oldtp]);
    } else {
        // ȯ (3) ﰢ Ѵ.
        // پ   ̸ Ѵ.
        retval = new Triangle;
        ShapeRep *newsr = retval;
        Thingp newtp = retval;

        // ܼϰ  Ŭ(ShapeRep) ι Ѵ.
        *newsr = *oldsr;

        //  ο ü ʵ带 Ѵ.
        retval->exemplarPointer = triangle;
        retval->p1 = old->p1;
        retval->p2 = old->p2;
        retval->p3 = old->p3;
        retval->color = Black;

        //   ȯ ü Ѵ.
        objectMap[oldtp] = newtp;
    }
    return retval;
}

Triangle::Triangle() { }
