/* Advanced C++ Programming Styles and Idioms */

#include <stdio.h>

#include "generic.h"

#define LocalScope(function)                        \
    struct name2(function, ForLocalScope) {         \
        void *parent;                               \
        name2(function, ForLocalScope) (void *p)    \
            { parent = p; }                         \
    public

#define EndLocalScope                               \
    } local(this)

#define EndOuterScope } local(0)

#define Parent(type, c)                             \
    ((name2(type,ForLocalScope)*) (c)->parent)

int main() {
    LocalScope(main):
        int a;
        int b;
        void foo() {
            LocalScope(foo):
                int a, b;

/* ⼭ !
  ,  ü   Ӵ   ִ.

void bar() {
    local.a = 3; local.b = 4;
    a = 5; b = 6;
    ...

̷  ذϰ   ǵ ߱  bar    a, b
  this ؼ LocalScope(foo) شϴ   a, b ϰ,
  a, b ؼ bar    ϴ  .
*/

                void bar() {
                    int a, b;
                    this->a = 3; this->b = 4;
                    a = 5; b = 6;
                    printf("bar: a=%d, %d, %d; b=%d, %d, %d\n",
                        a, this->a,
                        Parent(main, this)->a,
                        b, this->b,
                        Parent(main, this)->b);
                }
            EndLocalScope;

            local.bar();
            printf("foo: a=%d, b=%d\n", a, b);
        }
    EndOuterScope;
    local.a = 1;
    local.b = 2;
    local.foo();
}
