/* Advanced C++ Programming Styles and Idioms */

#include <stdio.h>
#include <string.h>

class String {
friend String operator+(const char*, const String&);
friend String operator+(const String&, const char*);
public:
    // ...
    int length() const { return ::strlen(rep); }
private:
    char *rep;
};

String operator+(const char* s, const String& S)
{
    String retval;
    retval.rep = new char[::strlen(s) + S.length()];
    ::strcpy(retval.rep, s);
    ::strcat(retval.rep, S.rep);
    return retval;
}

String operator+(const String& S, const char* s)
{
    String retval;
    retval.rep = new char[::strlen(s) + S.length()];
    ::strcpy(retval.rep, S.rep);
    ::strcat(retval.rep, s);
    return retval;
}

