/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include <iostream.h>
#include <stdlib.h>
#include <math.h>

// Complex Ŭ   ʱ⿡ ʿ ɸ ߰ؼ  ۼߴ.
class Complex {
public:
    Complex(double r = 0, double i = 0): rpart(r), ipart(i) { }
    //  (rpart,ipart)  . 
    friend ostream& operator<<(ostream &o, const Complex& c) {
        o << "(" << c.rpart << "," << c.ipart << ")"; return o;
    }
    // Է  (rpart,ipart)  . 
    friend istream& operator>>(istream &is, Complex& c) {
        int ch;
        const int bufSiz = 128;
        char buf[bufSiz];
        int buf_cnt = 0;
        if ((ch = is.get()) != '(') {
            is.clear(ios::badbit | is.rdstate());
            return is;
        };
        while (is && (ch = is.get()) != ',') {
            buf[buf_cnt++] = (char) ch;
        }
        buf[buf_cnt] = '\0';
        c.rpart = atoi(buf);
        buf_cnt = 0;
        while (is && (ch = is.get()) != ')') {
            buf[buf_cnt++] = (char) ch;
        }
        buf[buf_cnt] = '\0';
        c.ipart = atoi(buf);
    }

    // ũ  Ÿ 밪 Ѵ.
    int operator< (const Complex& c) const {
        float left_sqrt = sqrt(rpart * rpart + ipart * ipart);
        float right_sqrt = sqrt(c.rpart * c.rpart + c.ipart * c.ipart);
        if (left_sqrt < right_sqrt) {
            return 1;
        } else {
            return 0;
        }
    }
private:
    double rpart, ipart;
};

template <class S>
void sort(S elements[], const int nelements) {
    int flip = 0, sz = nelements - 1;
    int j = 0;
    do {
        for (j = 0, flip = 0; j < sz; j++) {
            if (elements[j] < elements[j+1]) {
                S t = elements[j+1];
                elements[j+1] = elements[j];
                elements[j] = t;
                flip++;
            }
        }
    } while (flip);
}

int main() {
    Complex cvec[12];
    int i = 0;
    for (i = 0; i < 12; i++) cin >> cvec[i];
    sort(cvec, 12);    // sort(Complex[], const int) ȣѴ.
    for (i = 0; i < 12; i++) cout << cvec[i] << endl;
    return 0;
}
