/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include "7-4.h"

// ANSI C++ ŸϿ friend  Ŭ ̸ externó
//  ƾ Ѵ.
class ErsatzListElement;

class SetBase {
friend ErsatzListElement;
private:
    virtual int comparelt(const void*, const void*)
        const = 0;
    virtual int compareeq(const void*, const void*)
        const = 0;
};

class ErsatzListElement {
    // Ű  Ŭ̸, ̴   óϱ 
    // List ø νϽ ִٴ  ǹ
public:
    void *rep;
    int operator< (const ErsatzListElement& l) const {
        return theSet->comparelt(this,&l);
    }
    int operator==(const ErsatzListElement& l) const {
        return theSet->compareeq(this,&l);
    }
    ErsatzListElement(const void* v = 0) { rep = (void*)v; }
    ErsatzListElement(SetBase *s, void *v=0): theSet(s) {
        rep = v;
    }
private:
    SetBase *theSet;
};

template <class T> class Set: private SetBase {
public:
    void add(T t2) {
        ErsatzListElement t(this, new T(t2)); rep.put(t);
    }
    T get() {
        ErsatzListElement l=rep.get(); return *((T*)(l.rep));
    }
    void remove(const T&);
    int exists(const T& e) {
        ErsatzListElement t(this, (T*)&e);
        return rep.element(t);
    }
    Set<T> Union(const Set<T>&) const;
    Set<T> Intersection(const Set<T>&) const;
    int size() const { return rep.size(); }
    void sort() { rep.sort(); }
    Set();
private:
    List<ErsatzListElement> rep;
    int comparelt(const void* v1, const void* v2) const {
        const T* t1 = (const T*) v1;
        const T* t2 = (const T*) v2;
        return *t1<*t2;
    }
    int compareeq(const void* v1, const void* v2) const {
        const T* t1 = (const T*) v1;
        const T* t2 = (const T*) v2;
        return *t1==*t2;
    }
};

template <class T> Set<T>::Set() { }

#include <iostream.h>

int main() {
    Set<int> foo;
    Set<double> bar;
    foo.add(1);
    foo.add(2);
    cout << foo.get() << "\n";
    cout << foo.get() << "\n";
    bar.add(3.0);
    bar.add(4.0);
    cout << bar.get() << "\n";
    cout << bar.get() << "\n";
}
