/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

//   ӽ÷  Ÿ: Hours, Days, Dollars
typedef long Hours;
typedef long Days;
typedef long Dollars;

//   ӽ   Ŭ: Class, String, EmployeeId, Exemplar
class EmployeeId {
public:
    EmployeeId(long);
    EmployeeId();
};

class Class {
public:
    virtual Class *make() = 0;
    virtual Class *make(const char *name, EmployeeId id) = 0;
    virtual long printPaycheck() = 0;
    virtual void logTimeWorked(Hours) = 0;
};

class String {
public:
    String();
    String(const char*);
};


struct Exemplar { Exemplar(); };

class Employee: public Class {
public:
    Employee(Exemplar);
    Employee *make();
    Employee *make(const char *name, EmployeeId id);
    long printPaycheck();
    void logTimeWorked(Hours);
protected:
    Employee();
    Employee(const char *name, EmployeeId id);
private:
    Dollars salary;
    Days vacationAllotted, vacationUsed;
    String name;
    EmployeeId id;
};
