/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

#include <string>
#include <iostream.h>

class Exemplar { public: Exemplar() { } };

extern class Class *dollarsExemplar;

class Dollars;

class Days {
public:
    Days();
};

class Class {
public:
    //  ToInt ߰
    enum Directive { PrintPaycheck, TimeWorked, GiveRaise,
                     Salary, Stock, ToString, Value, ToInt };
    virtual Class *atPut(Directive key, Class *arg) = 0;
    virtual Class *at(Directive key) = 0;
    virtual Class *getNext() = 0;
    virtual Class *putNext(Class *) = 0;
    virtual Class *make(Class *param) = 0;
    virtual Class *make(int = 0, int = 0, int =0, int = 0);
    virtual int toInt() = 0;
};

class Employee: public Class {
public:
    Class *atPut(Directive key, Class *arg) {
        switch(key) {
        // Class:: Ŭ  縦 ٿ Ѵ.
        case Class::Salary:    salary = arg->toInt(); return this;
        //  Print PrintPaycheck 
// ǥ   εϴ ſ ܼϰ  ٷ ߴ.
//        case PrintPaycheck:     cerr << *this; return this;
        case Class::PrintPaycheck:     cerr << "salary: " << salary << endl; return this;
        default:        return 0;
        }
    }
    Class *at(Class::Directive key) {
        switch (key) {
        case Class::Salary:    return dollarsExemplar->make(salary);
        // . . . .
        default:        return 0;
        }
    }

    int toInt() { return salary; }
    // virtual  
    virtual Class *make(int i = 0, int j = 0, int  k = 0, int l = 0) = 0;
    // Class param --> Class *param
    virtual Class *make(Class *param) = 0;
    virtual Class *getNext() = 0;
    virtual Class *putNext(Class *) = 0;
protected:
    int salary;
    Days vacationAllotted, vacationUsed;
};

class VicePresident: public Employee {
public:
    Class *atPut(Directive key, Class *arg) {
        switch(key) {
        case GiveRaise: salary = arg->toInt() + salary;
                        stockOptions *= 1.05;
                        break;
        default:        return Employee::atPut(key, arg);
        }
        return this;
    }
    Class *at(Directive key) {
        switch (key) {
        case Stock:     return dollarsExemplar->make(stockOptions);
        // . . . .
        default:        // return Employee::at(key, arg);
                        //  Ÿ 
                        return Employee::at(key);
        }
    }
    Class *make(Class *param) {
//        at ѱ Ÿ Class *̹Ƿ  String Ÿ  string ŸԿ ؾ Ѵ.
//        name = (string) param->getNext()->at(ToString);
        // ToInt Class:: 縦 ٿ Ѵ.
        salary = (int)param->getNext()->at(Class::ToInt);
        stock = (int)param->getNext()->at(Class::ToInt);
    }
    Class *make(int i = 0, int j = 0, int k = 0, int l = 0) {
        //  !
        Class *n = new VicePresident(Exemplar());
        // VicePresident  ϱ ؼ Ÿ ȯ ʼ̴.
        VicePresident *vn = (VicePresident*) n;
        vn->salary = i; vn->stockOptions = j; return vn;
    }
    Class *getNext() { return 0; }
    Class *putNext(Class *) { return 0; }
    VicePresident(Exemplar) { }
private:
    //  Dollars Ŭ double Ÿ 
    double stockOptions;
    // stock name ߰
    int stock;
    string name;
};

Class *vpExemplar = new VicePresident(Exemplar());

class Dollars: public Class {
public:
    Class *atPut(Directive key, Class *arg) {
        switch(key) {
        // ToInt Class:: 縦 ٿ Ѵ.
        case Value:     rep = (int)arg->at(Class::ToInt); return this;
        default:        return Class::atPut(key, arg);
        }
        return this;
    }
    Class *at(Directive key) {
        switch (key) {
//  intergerExemplar  ʴ´.  Integer Ŭ ߰ؾ Ѵ.
//        case Value:     return integerExemplar->make((Class*)rep);
        // . . . .
        default:        // return Class::atPut(key, arg);
                        //   Ÿ   
                        return Class::at(key);
        }
    }
    int toInt() { return rep; }
    Class *make(int i = 0, int j = 0, int k = 0, int l = 0) {
        //  !
        Class *n = new Dollars(Exemplar());
        // Dollars  ϱ ؼ Ÿ ȯ ʼ̴.
        Dollars* dn = (Dollars*) n;
        dn->rep = i; return dn;
    }
    Class *make(Class* param) {
        //  !
        Class *n = new Dollars(Exemplar());
        // Dollars  ϱ ؼ Ÿ ȯ ʼ̴.
        Dollars* dn = (Dollars*) n;
        dn->rep = (int)param;
        return dn;
    }
    Class *getNext() { return 0; }
    Class *putNext(Class *) { return 0; }
    Dollars(Exemplar) { }
private:
    int rep;
};

Class *dollarsExemplar = (Class*) new Dollars(Exemplar());
