/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 2-1 */

#include <iostream.h>

const int STACK_SIZE = 10;

template<class T> class Stack {
public:
    Stack();
    Stack(int);
    ~Stack();
    T top() const;
    T pop();
    void push(T);
private:
    T *items;
    int sp;
};


template<class T> Stack<T>::Stack() {
    items = new T[STACK_SIZE];
    sp = -1;
}

template<class T> Stack<T>::Stack(int size) {
    items = new T[size];           
    sp = -1;
}

template<class T> Stack<T>::~Stack() {
    delete[] items;        
}

template<class T> T Stack<T>::top() const {
    return items[sp];
}

template<class T> T Stack<T>::pop() {
    return items[sp--];
}

template<class T> void Stack<T>::push(T t) {
    items[++sp] = t;
}

int main()
{
    Stack<long> q;
	
    q.push(23);
    cout << "push " << q.top() << endl;
	
    q.push(11);
    cout << "push " << q.top() << endl;

    cout << "pop " << q.pop() << endl;
    cout << "pop " << q.pop() << endl;

    return 0;
}
