/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 2-2 */

#include <iostream.h>
#include <stdio.h>

const int STACK_SIZE = 10;

class Stack {
public:
    Stack();
    Stack(int);
    Stack(FILE*);
    ~Stack();
	char top() const;
    char pop();
    void push(char);
    int  length();
private:
    char *items;
    int sp;
};

Stack::Stack() {
    items = new char[STACK_SIZE];
    sp = -1;
}

Stack::Stack(int size) {
    items = new char[size];                         
    sp = -1;
}

Stack::Stack(FILE* fp) {
    items = new char[STACK_SIZE];
    sp = -1;

    char ch = fgetc(fp);
    while (ch != EOF) {           // EOF = Ctrl+Z
        push(ch);
        ch = fgetc(fp);
    }
}

Stack::~Stack() {
    delete[] items;         
}

char Stack::top() const {
    return items[sp];
}

char Stack::pop() {
    return items[sp--];
}

void Stack::push(char i) {
    items[++sp] = i;
}

int Stack::length() {
    return sp + 1;
}

int main()
{
    Stack s = stdin;

    cout << endl << endl << "Stack conents: ";
    for (int i = s.length(); i > 0; i--)
	    cout << s.pop();
    cout << endl;

    return 0;
}
