/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 2-4 */

// curses example using Window class
//
extern "C" {
#include <curses.h>
}

// convert macros to inlines
//
#undef lines

#undef UNDEF
#define UNDEF(name) CUR_ ##name

#ifdef addch
inline int UNDEF(addch)(chtype ch) { return addch(ch); }
#undef addch
#define addch UNDEF(addch)
#endif

#ifdef waddch
inline int UNDEF(waddch)(WINDOW* w, chtype ch)  { return waddch(w, ch); }
#undef waddch
#define waddch UNDEF(waddch)
#endif

#ifdef addstr
inline int UNDEF(addstr)(const char* s) { return addstr(s); }
#undef addstr
#define addstr UNDEF(addstr)
#endif

#ifdef waddstr
inline int UNDEF(waddstr)(WINDOW* w, const char* s)  { return waddstr(w, s); }
#undef waddstr
#define waddstr UNDEF(waddstr)
#endif

#ifdef clear
#inline int UNDEF(clear)() { return clear(); }
#undef clear
#define clear UNDEF(clear)
#endif

#ifdef wclear
inline int UNDEF(wclear)(WINDOW* w)  { return wclear(w); }
#undef wclear
#define wclear UNDEF(wclear)
#endif

#ifdef erase
inline int UNDEF(erase)() { return erase(); }
#undef erase
#define erase UNDEF(erase)
#endif

#ifdef werase
inline int UNDEF(werase)(WINDOW* w)  { return erase(w); }
#undef werase
#define werase UNDEF(werase)
#endif

#ifdef getch
inline int UNDEF(getch)() { return getch(); }
#undef getch
#define getch UNDEF(getch)
#endif

#ifdef wgetch
inline int UNDEF(wgetch)(WINDOW* w)  { return wgetch(w); }
#undef wgetch
#define wgetch UNDEF(wgetch)
#endif

#ifdef getstr
inline int UNDEF(getstr)(char *s) { return getstr(s); }
#undef getstr
#define getstr UNDEF(getstr)
#endif

#ifdef wgetstr
inline int UNDEF(wgetstr)(WINDOW* w, char *s)  { return wgetstr(w, s); }
#undef wgetstr
#define wgetstr UNDEF(wgetstr)
#endif

#ifdef move
inline int UNDEF(move)(int x, int y) { return move(x, y); }
#undef move
#define move UNDEF(move)
#endif

#ifdef wmove
inline int UNDEF(wmove)(WINDOW* w, int x, int y)  { return wmove(w, x, y); }
#undef wmove
#define wmove UNDEF(wmove)
#endif

#ifdef refresh
inline int UNDEF(refresh)() { return refresh(); }
#undef refresh
#define refresh UNDEF(refresh)
#endif

#ifdef wrefresh
inline int UNDEF(wrefresh)(WINDOW* w)  { return wrefresh(w); }
#undef wrefresh
#define wrefresh UNDEF(wrefresh)
#endif

// Window class definition
//
class Window {
public:
    Window() {  w = ::initscr(); }
    ~Window() { ::endwin(); }

    int lines() { return (LINES); }
    int cols() { return (COLS); }

    int addch(const chtype ch) { return ::waddch(w, ch); }
    int addstr(const char* s) { return ::waddstr(w, s); }
    int clear() { return ::wclear(w); }
    int erase() { return ::werase(w); }
    int getch() { return ::wgetch(w); }
    int getstr(char* s) { return ::wgetstr(w, s); }
    int move(const int i, const int j) { return ::wmove(w, i, j); }
    int refresh() { return ::wrefresh(w); }

private:
    WINDOW* w;
};

int main() {

    Window*  w = new Window();
    int nlines = w->lines();
    int ncols  = w->cols();

    w->move(0, 0);
    w->addstr("enter a character to fill the window..");
    int ch = w->getch();

    w->clear();
    for (int i = 0; i < nlines - 1; i++)
        for (int j = 0; j < ncols; j++) {
            w->move(i, j);
            w->addch(ch);
        }

    w->refresh();
    delete w;

    return 0;
}







