/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 2-7 */

// Constructor identifies its own invocation path by checking stack size.

#include <iostream.h>

const  int STACK_SIZE = 1024; // stack size depends on the compiler.
static int* stackPtr = 0;

class A {
public:
    A() {
        cout << "Begin constructor..." << endl;

        cout << "\tStack pointer is " << stackPtr << endl;
        cout << "\tMy address is "<<  (int *)this << endl;
		
        bool automatic = (stackPtr > (int *)this) && 
                        ((stackPtr - STACK_SIZE) < (int *)this);
        if (automatic)
            cout << "\tI am an automatic variable. " << endl;
        else
            cout << "\tI am NOT an automatic variable. " << endl;
	
        cout << "End constructor... " << endl << endl;
    }
};

int main() {
    int i = 0;
    stackPtr = &i;

    cout << "Declaring an automatic variable." << endl;
    A a;

    cout << "Invoking new()." << endl;
    A* aPtr = new A;

    return 0;
}

