/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-13 */

#include <iostream.h>
#include <string.h>

// String class definition
//
class String {
public:
    // constructor & descructor
    String() {
        rep = new char[1];
        rep[0] = '\0';
    }

    String(const char* s) {
        int lengthOfOriginal = ::strlen(s) + 1;
        rep = new char[lengthOfOriginal];
        ::strcpy(rep, s);
    }

    String(const String& s) {
        rep = new char[s.length() + 1];
        ::strcpy(rep, s.rep);
    }

    ~String() {
        delete[] rep;
    }

    // operators
    String& operator=(const String& s) {
        if (rep != s.rep) {
            delete[] rep;
            int lengthOfOriginal = s.length() + 1;
            rep = new char[lengthOfOriginal];
            ::strcpy(rep, s.rep);
        }
        return *this;
    }

    // other public member functions
    int length() const {
        return ::strlen(rep);
    }
    const char* C_rep() { return rep; }

private:
    char *rep;
};

// overloading global function strlen()
//
int strlen(String& s) {
    return s.length();
}

// function main() for testing
//
int main() 
{
    String s = "This is a sample string.";

    cout << "original string s = " << s.C_rep() << endl;
    cout << "length using conversion member function, s.C_rep()   = " << ::strlen(s.C_rep()) << endl;
    cout << "length using globally overloaded functions, strlen() = " << strlen(s) << endl;
 
    return 0;
}
