/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-13 */

#include <iostream.h>
#include <string.h>

// forward referencing
class String;

// StringPointer class definition
//
class StringPointer {
public:
    // constructor & descructor
    StringPointer() { p = 0; }
    StringPointer(const StringPointer& sp) { p = sp.p; }
    StringPointer(String* s) { p = s; }
    ~StringPointer() { p = 0; }

    // operators
    StringPointer& operator=(const StringPointer& sp) {
        p = sp.p;
        return *this;
    }

    String* operator->() const {
        return p;
    }

    String& operator*() const {
        return (*p);
    }

    // other public functions
    
private:
    // private data
    String* p;
};

// String class definition
//
class String {
public:
    // constructor & descructor
    String() {
        rep = new char[1];
        rep[0] = '\0';
    }

    String(const char* s) {
        int lengthOfOriginal = ::strlen(s) + 1;
        rep = new char[lengthOfOriginal];
        ::strcpy(rep, s);
    }

    String(const String& s) {
        rep = new char[s.length() + 1];
        ::strcpy(rep, s.rep);
    }

    ~String() {
        delete[] rep;
    }

    // operators
    String& operator=(const String& s) {
        if (rep != s.rep) {
            delete[] rep;
            int lengthOfOriginal = s.length() + 1;
            rep = new char[lengthOfOriginal];
            ::strcpy(rep, s.rep);
        }
        return *this;
    }

    StringPointer operator&() {
        return StringPointer(this);
    }

    // other public member functions
    int length() const {
        return ::strlen(rep);
    }
    const char* C_rep() { return rep; }

private:
    char *rep;
};

int main()
{
    String s = "This is a sample string.";
    StringPointer sp = &s;
    
    cout << "original string:   " << s.C_rep() << endl;
    cout << "string pointer *:  " << (*sp).C_rep() << endl;
    cout << "string pointer ->: " << sp->C_rep() << endl;

    return 0;
}
