/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-15 */

#include <iostream.h>

class Int {
friend ostream& operator<<(ostream&, const Int&);

public:
    // constructor & descructor
    Int() { rep = 0; }
    Int(const Int& i) { rep = i.rep; }
    Int(long l) { rep = l; }
    ~Int() { }

    // operators
    Int& operator=(const Int& i) {
        rep = i.rep;
        return *this;
    }

    Int operator+(const Int& i) const {
        return operator+(i.rep);
    }

    Int operator+(const long& l) const {
        Int retval;
        long mask = 1 << l;
        retval.rep = rep | mask;
        return retval;
    }

    Int operator-(const long& l) const {
        Int retval;
        long mask = -1L & ~(1 << l);
        retval.rep = rep & mask;
        return retval;
    }

private:
    // private data
    long rep;
};

ostream& operator<<(ostream& os, const Int& i) {
    os << i.rep;
    return os;
}

int main() {

    Int i = 0, j = 0;
    
    j = i + 25 + 15 + 14 + 2;
    cout << "j = i + 25 + 15 + 14 + 2 = " << oct << j << endl;

    j = j - 25 - 15 - 14 - 2;
    cout << "j = j - 25 - 15 - 14 - 2 = " << oct << j << endl;

    return 0;
}
