/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-3 */

#include <iostream.h>
#include <string.h>

// String class definition
class String {
friend ostream& operator<<(ostream&, const String&);

public:
    // constructor & descructor
    String() {
        rep = new char[1]; 
        rep[0] = '\0';
    }

	String(const char* s) {
        int lengthOfOriginal = ::strlen(s) + 1;
        rep = new char[lengthOfOriginal];
        ::strcpy(rep, s);
    }
	
    String(const String& s) {
        rep = new char[s.length() + 1];
        ::strcpy(rep, s.rep);
    }

    ~String() {
        delete[] rep;
    }

    // operator
    String& operator=(const String& s) {
        if (rep != s.rep) {
            delete[] rep;
            int lengthOfOriginal = s.length() + 1;
            rep = new char[lengthOfOriginal];
            ::strcpy(rep, s.rep);
        }
        return *this;
    }

    String operator()(const int j, const int k) const;	

    // other public functions
    int length() const { 
        return ::strlen(rep); 
    }

private:
    char *rep;
};

ostream& operator<<(ostream& os, const String& s) {
    os << s.rep;
    return os;
}

String String::operator()(const int j, const int k) const {
    int startIndex = -1, substrLength = 0, endIndex = -1;

    if (j > 0 && k > 0) {
        startIndex   = j - 1;
        substrLength = k;

    } else if (j > 0 && k < 0) {
        startIndex   = j + k;
        substrLength = -k;

    } else if (j < 0 && k > 0) {
        startIndex   = length() + j;
        substrLength = k;

    } else if (j < 0 && k < 0) {
        startIndex   = length() + j + k + 1;
        substrLength = -k;
    }

    endIndex = startIndex + substrLength - 1;

    if (startIndex >= 0 && startIndex < length() &&
	    endIndex >= 0 && endIndex < length()) {
        char* substr = new char[substrLength + 1];
        ::strncpy(substr, &rep[startIndex], substrLength * sizeof(char));
        substr[substrLength] = '\0';
		
        String retval = String(substr);
        delete[] substr;

        return retval;
	} 
	
    return String("");
}

int main() {

    String s = "abcdefg";
    cout << "Original string = " << s << endl;

    String t1 = s(3, 2);
    cout << "abcdefg(3,2) = " << t1 << endl;

    String t2 = s(-3, 2);
    cout << "abcdefg(-3, 2) = " << t2 << endl;

    String t3 = s(3, -2);
    cout << "abcdefg(3,-2) = " << t3 << endl;

    String t4 = s(-3, -2);
    cout << "abcdefg(-3, -2) = " << t4 << endl;

    cout << "Original string = " << s << endl; 
    return 0;
}
