/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-9 */

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>

using namespace std;

int prints(const char* s) {
    int length = strlen(s);
    for (int i = 0; i < length; i++)
        putchar(s[i]);
    return 0;
}

int printf(const char* format, ...) {
    va_list args;
    va_start(args, format);

    for ( ; *format != 0; ++format) {
        if ( *format != '%') {
            putchar(*format);
            continue;
        }

        ++format;
        if (*format == 'd') {            // handle %d
           int i = va_arg(args, int);
           char s[16];
           sprintf(s, "%d", i);
           prints(s);
        } 
        else if (*format == 's') {       // handle %s
           char* s = (char *)va_arg(args, int);
           prints(s);
        }
        else if (*format == 'S') {       // handle %S
           string* s = (string *)va_arg(args, int);
           prints(s->c_str());
        }
        else {
            putchar('%');
            putchar(*format);
        }
    }
    return 0;
}

int main() 
{
    printf("a simple string with no arg\n");

    int i = 4;
    printf("integer arg = %d\n", i);

    char s[20];
    strcpy(s, "char string");
    printf("char string arg = %s\n", s);

    string S("class string");
    printf("class string arg = %S\n", &S);

    printf("integer = %d, char string = %s, class string=%S\n", i, s, &S);

    return 0;
}
