/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 4-2 */

#include <iostream.h>

// Sample class definition
//
class classA {
public:
    int   data1;
    
    classA()  { data1 = data2 = data3 = 0; }
    classA(const classA& ca) {
        data1 = ca.data1; 
        data2 = ca.data2;
        data3 = ca.data3;
    }
    ~classA() { }
    
    classA& operator=(const classA& ca) {
        data1 = ca.data1;
        data2 = ca.data2;
        data3 = ca.data3;
        return *this;
    }

    int   getData1() const      { return data1; }
    void  setData1(const int i) { data1 = i; }

protected:
    int   data2;
    int   getData2() const      { return data2; }
    void  setData2(const int i) { data2 = i; }

private:
    int   data3;
    int   getData3() const      { return data3; }
    void  setData3(const int i) { data3 = i; }
};

// Equivalent structure definition
//
typedef struct structureA {
    int data1;
    int _data2;
    int __data3;
} structA;

void structAdefaultConstruct(structA* psa) { 
    psa->data1    = 0;
    psa->_data2   = 0;
    psa->__data3  = 0;
}

void structAcopyConstruct(structA* psa, structA* ptemp) {
    psa->data1    = ptemp->data1;
    psa->_data2   = ptemp->_data2;
    psa->__data3  = ptemp->__data3;
}

void structAdestruct(structA* psa) { }

void structAcopy(structA* psa, structA* ptemp) {
    psa->data1    = ptemp->data1;
    psa->_data2   = ptemp->_data2;
    psa->__data3  = ptemp->__data3;
}

int  structAgetData1(structA* psa)           { return psa->data1; }
void structAsetData1(structA* psa, int i)    { psa->data1 = i; }

int  _structAgetData2(structA* psa)          { return psa->_data2; }
void _structAsetData2(structA* psa, int i)   { psa->_data2 = i; }

int  __structAgetData3(structA* psa)         { return psa->__data3; }
void __structAsetData3(structA* psa, int i)  { psa->__data3 = i; }


// Function main() for testing
//
int main() {
    // using classA
    classA ca1, ca2;
    ca1.setData1(1);
    ca2 = ca1;
   
    // using structA
    structA sa1, sa2;
    structAdefaultConstruct(&sa1);
    structAdefaultConstruct(&sa2);

    structAsetData1(&sa1, 1);
    structAcopy(&sa2, &sa1);
    
    structAdestruct(&sa1);
    structAdestruct(&sa2);

    // But can not prevent the illegal access
    //
    structA sa3;
    sa3._data2 = 5;
    __structAsetData3(&sa2, 5);

    return 0;
}
