/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 6-5 */

// defining associative array using enumerated values as key

#include <iostream>
#include <string>
#include <string.h>

using namespace std;

class AssociativeArray {
public:
    enum Key { K_print = 0,
               K_size,
               K_CircularList_example,
               K_AssociativeArray_example };
               
    AssociativeArray(int size=300): _position(K_size + 1), _size(size) { 
        _pa   = new void*[_size];
    }

    ~AssociativeArray() {
        if (_pa) delete[] _pa;
    }
    
    void  atPut(void* element, const Key key) {
        if (key == K_print) {
            cout << "<contents of the AssociativeArray>" << endl;
            for (int i = K_size + 1; i < _position; i++) {
                cout << "key: " << i << ", value: " << (int) _pa[i] << endl;
            }
        } else if (key == K_size) {
            int i;
            void ** _tpa = new void*[(int) element];
            if (_pa) {
                for (i = K_size + 1; i < _position; i++) {
                    if ((int) element == i) {
                        break;
                    } else {
                        _tpa[i] = _pa[i];
                    }
                }
                _size = (int) element;
                delete [] _pa;
                _pa = _tpa;
	    }
        } else if (_pa && key >= 0 && key < _size) {
            _pa[key] = element;
            _position++;
        }
    }
    void* at(const Key key) {
        if (key == K_size) {
            return (void*) _size;
        } else if (_pa && key >=0 && key < _size)
            return _pa[key];
        else
            return (void *)0;
    }
private:
    int     _position; 
    int     _size;
    void**  _pa;
};

int main() {
    AssociativeArray a;
    a.atPut((void *)233, AssociativeArray::K_AssociativeArray_example);
    a.atPut((void *)230, AssociativeArray::K_CircularList_example);
    a.atPut((void *)0, AssociativeArray::K_print);

    int circlistPage = (int)a.at(AssociativeArray::K_CircularList_example);
    cout << "value should be 230 = " << circlistPage << endl;

    a.atPut((void *)20, AssociativeArray::K_size);
    a.atPut((void *)0, AssociativeArray::K_print);
    int size = (int)a.at(AssociativeArray::K_size);
    cout << "size should be 20 = " << size << endl;

    return 0;
}
